from curl_http import HTTP
import lxml.html
import json
import xmltodict


class BaseAPI(HTTP):
    def __init__(self):
        super(BaseAPI, self).__init__()  # 执行父类初始化方法

    @staticmethod
    def get_table(doc):
        doc = doc.replace("></td>",">.</td>")
        doc = doc.replace("<br>","")
        root = lxml.html.fromstring(doc)
        tables = []
        for tbl in root.xpath('//table'):
            elements = tbl.xpath('.//tr')
            table = []
            cnt = len(elements)
            if cnt > 1:
                index = elements[0].xpath("./td//text()")
                for element in elements[1:]:
                    value = element.xpath("./td//text()")
                    table.append(dict(zip(index, value)))
            else:
                table.append(elements[0].xpath("./td//text()"))
            tables.append(table)
        return tables

    @staticmethod
    def get_school_table(doc):
        doc = doc.replace("></td>",">.</td>")
        doc = doc.replace("a>.</td>","a></td>")
        doc = doc.replace("<br>","")
        root = lxml.html.fromstring(doc)
        tables = []
        for tbl in root.xpath('//table'):
            elements = tbl.xpath('.//tr')
            table = []
            cnt = len(elements)
            if cnt > 1:
                index = elements[0].xpath("./td//text()")
                for element in elements[1:]:
                    value = element.xpath("./td//text()")
                    table.append(dict(zip(index, value)))
            else:
                table.append(elements[0].xpath("./td//text()"))
            tables.append(table)
        return tables

    @staticmethod
    def get_json(doc):
        return json.loads(doc)

    @staticmethod
    def get_xml(doc):
        return xmltodict.parse(doc)


